package custom.common;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.UnknownHostException;

public class Util {
	public static Match match_concept(String o1_label, String c1, String o2_label, String alignment_method, float threshold) {

		String fromserver;
		Socket kkSocket;
		try {
			kkSocket = new Socket("localhost", 4444);
			PrintWriter out = new PrintWriter(kkSocket.getOutputStream(), true);
			BufferedReader in = new BufferedReader(new InputStreamReader(
					kkSocket.getInputStream()));

			String request = "MATCH_CONCEPT " + o1_label + " " + c1 + " " + o2_label + " " + alignment_method + " " + threshold;
			out.println(request);
			fromserver = in.readLine();

			System.out.println("From server: " + fromserver);

			// ### cleanup
			out.close();
			in.close();
			kkSocket.close();
			
			//### The response will be something like "matchingConcept 0.9523"
			String [] parts = fromserver.split(" ");
			
			if (parts.length > 1) {
				String matching_concept = parts[0];
				float strength = Float.valueOf(parts[1]);
				return new Match(matching_concept, strength);
			} else {
				return new Match();
			}
			
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return new Match();
	}
}
