//----------------------------------------------------------------------------
// Copyright (C) 2003  Rafael H. Bordini, Jomi F. Hubner, et al.
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// 
// To contact the authors:
// http://www.inf.ufrgs.br/~bordini
// http://www.das.ufsc.br/~jomi
//----------------------------------------------------------------------------

package custom.stdlib;

import jason.JasonException;
import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.Atom;
import jason.asSyntax.ListTerm;
import jason.asSyntax.ListTermImpl;
import jason.asSyntax.Literal;
import jason.asSyntax.LogicalFormula;
import jason.asSyntax.Plan;
import jason.asSyntax.PlanBody;
import jason.asSyntax.PlanBodyImpl;
import jason.asSyntax.Pred;
import jason.asSyntax.Term;
import jason.asSyntax.Trigger;
import jason.asSyntax.VarTerm;
import jason.asSyntax.PlanBody.BodyType;
import jason.asSyntax.Trigger.TEOperator;
import jason.asSyntax.Trigger.TEType;

/**
 * <p>
 * Internal action: <b>
 * <code>custom.stdlib.extract_ontology_label(<i>Trigger</i>, <i>Label</i>)</code>
 * </b>.
 * </p>
 * 
 * <p>
 * Description: Extracts the ontology label from a trigger
 * </p>
 * <p>
 * Examples:
 * <ul>
 * 
 * //### TODO add an example
 * <li> <code>custom.stdlib.extract_ontology_label(Trigger, Label)</code>: .</li>
 * 
 * </ul>
 * </p>
 */
public class create_plan extends DefaultInternalAction {

	@Override
	public int getMinArgs() {
		return 3;
	}

	@Override
	public int getMaxArgs() {
		return 3;
	}

	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args) {
		
		Pred label = new Pred("test1");
		
		Trigger tr = new Trigger(TEOperator.add, TEType.achieve, (Literal) args[0]);
		
		LogicalFormula lf = Literal.LTrue;
		
		PlanBodyImpl pb = new PlanBodyImpl();
		PlanBodyImpl p1 = new PlanBodyImpl(BodyType.internalAction, Literal.parseLiteral(".print(\"wewe\")"));
		pb.add(p1);
		pb.add(p1);
		
		Plan p = new Plan(label, tr, lf, pb);
		
		try {
			ts.getAg().getPL().add(p);
		} catch (JasonException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		System.out.println("adassas");

		return true;
	}

	/**
	 * Adapts a plan changing its functor to $oldFunctor
	 * 
	 * @param plan
	 * @param oldFunctor
	 * @return
	 */
	private Plan adaptPlan(Plan plan, Atom oldFunctor) {
		Trigger t = plan.getTrigger();
		System.out.println("plan: " + plan);
		System.out.println("plan trigger: " + t);

		Pred newTriggerLiteral = new Pred(oldFunctor);
		newTriggerLiteral.addTerms(t.getLiteral().getTerms());
		newTriggerLiteral.addAnnots(t.getAnnots());

		Trigger newTrigger = new Trigger(t.getOperator(), t.getType(),
				newTriggerLiteral);
		Plan adaptedPlan = new Plan(plan.getLabel(), newTrigger, plan
				.getContext(), plan.getBody());

		return adaptedPlan;
	}

}
