//----------------------------------------------------------------------------
// Copyright (C) 2003  Rafael H. Bordini, Jomi F. Hubner, et al.
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// 
// To contact the authors:
// http://www.inf.ufrgs.br/~bordini
// http://www.das.ufsc.br/~jomi
//----------------------------------------------------------------------------


package custom.stdlib;

import jason.asSemantics.DefaultInternalAction;

import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.Atom;
import jason.asSyntax.NumberTermImpl;
import jason.asSyntax.Pred;
import jason.asSyntax.StringTerm;
import jason.asSyntax.StringTermImpl;
import jason.asSyntax.Term;
import jason.asSyntax.VarTerm;

/**
  <p>Internal action:
  <b><code>custom.stdlib.extract_ontology_label(<i>Trigger</i>, <i>Label</i>)</code></b>.
  </p>
  
  <p>Description: Extracts the ontology label from a trigger</p>
  <p>Examples:<ul> 

  //### TODO add an example
  <li> <code>custom.stdlib.extract_ontology_label(Trigger, Label)</code>: .</li>

  </ul>
  </p>
  
 */
public class generate_hash extends DefaultInternalAction {
    
    @Override public int getMinArgs() { return 2; }
    @Override public int getMaxArgs() { return 2; }

    @Override
    public Object execute(TransitionSystem ts, Unifier un, Term[] args) throws Exception {
        // checkArguments(args);
    	
    	VarTerm trigger_var = (VarTerm)args[0];
    	
    	// System.out.println("Retrieving ontology annotation..." + l);
    	
    	StringTerm t = (StringTerm) trigger_var.getValue();
    	
    	String str = t.getString() + System.currentTimeMillis();

    	/*
    	byte[] bytesOfMessage = str.getBytes("UTF-8");

    	MessageDigest md = MessageDigest.getInstance("MD5");
    	byte[] thedigest = md.digest(bytesOfMessage);
    	
    	String out = 'm' + thedigest.toString();
		*/
    	
    	Pred hash = new Pred("hash");
    	hash.addTerm(new Atom("a" + Math.abs(str.hashCode())));
    	
		return un.unifies(args[1], hash);
    }
    
}
