package custom.stdlib;

import jason.JasonException;
import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.InternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.Atom;
import jason.asSyntax.ListTerm;
import jason.asSyntax.StringTerm;
import jason.asSyntax.StringTermImpl;
import jason.asSyntax.Term;
import jason.asSyntax.VarTerm;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.Iterator;

import custom.asSemantics.OntologyAgent;

public class match_concept extends jason.stdlib.send {
    
    private static InternalAction singleton = null;
    public static InternalAction create() {
        if (singleton == null) 
            singleton = new match_concept();
        return singleton;
    }

    @Override public int getMinArgs() { return 3; }
    @Override public int getMaxArgs() { return 3; }

    @Override protected void checkArguments(Term[] args) throws JasonException {
        // super.checkArguments(args); // check number of arguments
    	//### should contro
    }

    @Override
    /**
     * args[0] : the ontology the original concept comes from
     * args[1] : the concept to be matched against
     * args[2] : the other ontology ontology the original concept comes from
     * args[3] : the matching concept
     * args[4] : the strength of the relationship
     */
    public Object execute(TransitionSystem ts, Unifier un, Term[] args) throws Exception {

    	//### Retrieve ontologies labels
    	// String c1 = ((Atom)args[0]).getFunctor();
    	// String label_o1 = ((Atom)args[1]).getFunctor();
    	// String path = ((VarTerm)args[2]).getString();
    	//### functors or strings?
    	
    	String o1_label = ((Atom)args[0]).getFunctor();
    	String c1 = ((Atom)args[1]).getFunctor();
		String o2_label = ((Atom)args[2]).getFunctor();

		String fromserver;
		Socket kkSocket;
		try {
			kkSocket = new Socket("localhost", 4444);
			PrintWriter out = new PrintWriter(kkSocket.getOutputStream(), true);
			BufferedReader in = new BufferedReader(new InputStreamReader(
					kkSocket.getInputStream()));

			String request = "MATCH_CONCEPT " + o1_label + " " + c1 + " " + o2_label;
			out.println(request);
			fromserver = in.readLine();

			System.out.println(fromserver);

			// ### cleanup
			out.close();
			in.close();
			kkSocket.close();
			
			//### The response will be something like "matchingConcept 0.9523"
			String [] parts = fromserver.split(" ");
			String matching_concept = parts[0];
			float strength = Float.valueOf(parts[1]);
			
			//### unifies the matching concept and strength
			return un.unifies(args[3], new Atom(matching_concept)) && un.unifies(args[4], new jason.asSyntax.NumberTermImpl(strength));
			
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return false;
    }
    
    protected boolean compare(Term a, Term t) {
        return a.compareTo(t) > 0;
    }
}
