package custom.stdlib;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.UnknownHostException;

import jason.JasonException;
import jason.asSemantics.InternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.Atom;
import jason.asSyntax.StringTerm;
import jason.asSyntax.StringTermImpl;
import jason.asSyntax.Term;

import custom.asSemantics.OntologyAgent;

public class register_ontology_oa extends jason.stdlib.send {

	private static InternalAction singleton = null;

	public static InternalAction create() {
		if (singleton == null)
			singleton = new register_ontology_oa();
		return singleton;
	}

	@Override
	public int getMinArgs() {
		return 2;
	}

	@Override
	public int getMaxArgs() {
		return 2;
	}

	@Override
	protected void checkArguments(Term[] args) throws JasonException {
		super.checkArguments(args); // check number of arguments
	}

	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
			throws Exception {

		// OntologyAgent ag = (OntologyAgent) (ts.getAg());

		String URI = ((StringTerm) args[0]).getString();
		// String label = ((StringTerm) args[1]).getString();
		String label = ((Atom) args[1]).toString();

		String fromserver;
		Socket kkSocket;
		try {
			kkSocket = new Socket("localhost", 4444);
			PrintWriter out = new PrintWriter(kkSocket.getOutputStream(), true);
			BufferedReader in = new BufferedReader(new InputStreamReader(
					kkSocket.getInputStream()));

			String request = "REGISTER_ONTOLOGY " + URI + " " + label;
			out.println(request);
			fromserver = in.readLine();

			System.out.println(fromserver);

			// ### cleanup
			out.close();
			in.close();
			kkSocket.close();
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		Term result = new Atom("success");
		return un.unifies(args[2], result);
	}

	protected boolean compare(Term a, Term t) {
		return a.compareTo(t) > 0;
	}
}
