package main;

// Alignment API classes
import org.semanticweb.owl.align.Alignment;
import org.semanticweb.owl.align.AlignmentProcess;
import org.semanticweb.owl.align.AlignmentVisitor;

// Alignment API implementation classes
import fr.inrialpes.exmo.align.impl.BasicAlignment;
import fr.inrialpes.exmo.align.impl.BasicParameters;
import fr.inrialpes.exmo.align.impl.method.StringDistAlignment;
import fr.inrialpes.exmo.align.impl.renderer.RDFRendererVisitor;
import fr.inrialpes.exmo.align.ling.JWNLAlignment;

// SAX standard classes
import org.xml.sax.SAXException;

// Java standard classes
import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.io.OutputStreamWriter;
import java.io.File;
import java.net.URI;
import java.util.Properties;

public class Align1 {

	/**
	 * @param args
	 */
	public static void main( String[] args ) {
		URI onto1 = null;
		URI onto2 = null;
		Properties params = new BasicParameters();

		try {
		    // Loading ontologies
			/*
		    if (args.length >= 2) {
			onto1 = new URI( args[0] );
			onto2 = new URI( args[1] );
		    } else {
			System.err.println("Need two arguments to proceed");
			return ;
		    }
		    */
			
			onto1 = new URI( "file:///Users/hexe/projects/DISI/labspec1/align-4/ont/Supermarket.owl" );
			onto2 = new URI( "file:///Users/hexe/projects/DISI/labspec1/align-4/ont/DomesticRobot.owl" );

		    // Aligning
		    // AlignmentProcess a1 = new StringDistAlignment();
			AlignmentProcess a1 = new JWNLAlignment();
			
		    a1.init ( onto1, onto2 );
		    a1.align( (Alignment)null, params );

		    // Outputing
		    PrintWriter writer = new PrintWriter (
					  new BufferedWriter(
			                   new OutputStreamWriter( System.out, "UTF-8" )), true);
		    AlignmentVisitor renderer = new RDFRendererVisitor(writer);
		    a1.render(renderer);
		    writer.flush();
		    writer.close();

		} catch (Exception e) { e.printStackTrace(); };
	    }

}
