package server.alignment;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.net.URI;
import java.util.Properties;

import org.semanticweb.owl.align.Alignment;
import org.semanticweb.owl.align.AlignmentException;
import org.semanticweb.owl.align.AlignmentProcess;
import org.semanticweb.owl.align.AlignmentVisitor;

import fr.inrialpes.exmo.align.impl.BasicParameters;
import fr.inrialpes.exmo.align.impl.renderer.RDFRendererVisitor;
import fr.inrialpes.exmo.align.ling.JWNLAlignment;

public class JWNLAligner extends Aligner {

	@Override
	/**
	 * returns the alignment filename
	 */
	public String align(String o1_label, String o2_label, URI o1_uri, URI o2_uri, String alignment_path_folder) {
		AlignmentProcess a1 = new JWNLAlignment();

		Properties props = new BasicParameters();

		System.out.println("OServer: aligning ontologies " + o1_uri + " ("
				+ o1_label + ") and " + o2_uri + " (" + o2_label + ")");

		try {
			a1.init(o1_uri, o2_uri);
			a1.align((Alignment) null, props);

			String filename = alignment_path_folder + '/' + o1_label + "_" + o2_label
					+ "_jwnl_alignment.rdf";

			FileWriter fw = new FileWriter(filename);

			// Outputing
			// PrintWriter writer = new PrintWriter(new BufferedWriter(new
			// OutputStreamWriter(System.out, "UTF-8")), true);
			PrintWriter writer = new PrintWriter(new BufferedWriter(fw), true);
			AlignmentVisitor renderer = new RDFRendererVisitor(writer);
			a1.render(renderer);
			writer.flush();
			writer.close();

			System.out.println("Alignment successful: generated file "
					+ filename);

			return filename;
					} catch (AlignmentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// TODO Auto-generated method stub
		return null;
	}

}
